<template>
  <div class="col">
    <q-form ref="form" @submit="onSubmit" @reset="onReset">
      <div class="row q-col-gutter-sm">
        <div class="col">
          <q-select
            outlined
            clearable
            dense
            options-dense
            use-input
            emit-value
            map-options
            label="Marca *"
            :readonly="editing"
            :options="brandOptions"
            :rules="[val => !!val || 'Campo es requerido.']"
            @filter="filterBrands"
            @input="getProducts"
            v-model="draft.brand"
          >
            <template v-slot:no-option>
              <q-item>
                <q-item-section class="text-grey">
                  No results
                </q-item-section>
              </q-item>
            </template>
          </q-select>
        </div>
        <div class="col">
          <q-select
            outlined
            clearable
            dense
            options-dense
            use-input
            emit-value
            map-options
            label="Nombre del producto *"
            :readonly="editing"
            :options="productOptions"
            :rules="[val => !!val || 'Campo es requerido.']"
            @filter="filterProducts"
            @input="getPresentations"
            v-model="draft.product"
          >
            <template v-slot:no-option>
              <q-item>
                <q-item-section class="text-grey">
                  No results
                </q-item-section>
              </q-item>
            </template>
          </q-select>
        </div>
      </div>
      <div class="row q-col-gutter-sm">
        <div class="col">
          <q-select
            outlined
            clearable
            dense
            options-dense
            use-input
            label="Presentación *"
            :options="presentationOptions"
            :readonly="editing"
            :rules="[val => !!val || 'Campo es requerido.']"
            @filter="filterPresentations"
            v-model="draft.presentation"
          >
            <template v-slot:no-option>
              <q-item>
                <q-item-section class="text-grey">
                  No results
                </q-item-section>
              </q-item>
            </template>
          </q-select>
        </div>
        <div class="col">
          <q-input
            outlined
            dense
            label="Precio *"
            mask="#.##"
            fill-mask="0"
            reverse-fill-mask
            input-class="text-right"
            :rules="[val => !!val || 'Campo es requerido.']"
            v-model.number="draft.price"
          />
        </div>
      </div>
      <div class="q-pb-lg">
        <q-btn flat label="Limpiar" type="reset" color="primary" class="q-ml-sm"/>
        <q-btn :label="submit" type="submit" color="primary"/>
      </div>
    </q-form>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

export default {
  props: ['product', 'editing'],
  data () {
    return {
      draft: this.product
    }
  },
  mounted () {
    this.$store.dispatch('shared/getBrands')
  },
  watch: {
    'product': function (data) {
      this.draft = JSON.parse(JSON.stringify(data))
      if (this.draft.brand) {
        this.getProducts(this.draft.brand)
      }
      if (this.draft.product) {
        this.getPresentations(this.draft.product)
      }
    }
  },
  computed: {
    ...mapGetters({
      country: 'auth/country',
      brandOptions: 'shared/brandOptions',
      productOptions: 'shared/productOptions',
      presentationOptions: 'shared/presentationOptions'
    }),
    submit () {
      return this.editing ? 'Actualizar' : 'Guardar'
    }
  },
  methods: {
    filterBrands (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHBRANDS', search)
      })
    },
    getProducts (brand) {
      if (brand) {
        this.$store.dispatch('shared/getProducts', { brand: brand._id, country: this.country })
      }
    },
    filterProducts (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHPRODUCTS', search)
      })
    },
    getPresentations (product) {
      if (product) {
        this.$store.dispatch('shared/getPresentations', { product: product._id })
      }
    },
    filterPresentations (search, update) {
      update(() => {
        this.$store.commit('shared/SEARCHPRESENTATIONS', search)
      })
    },
    async onSubmit () {
      await this.$refs.form.validate().then(success => {
        if (success) {
          this.$emit('save', this.draft)
          // pendiente crear la validación para cuando un local, ya tenga el producto registrado
        }
      })
    },
    onReset () {
      this.draft = JSON.parse(JSON.stringify(this.product))
    }
  }
}
</script>
